##########################################################################
# έp (@)                                                            #
# Anderson et al., Statistics for Business & Economics (14th Edition)    #
# Chapter 4                                                              #
# d~ ߬FvjǲέpǨt                                            #
# http://www.hmwu.idv.tw/                                                #
##########################################################################



######################################
# Section 4.1                        #
######################################

factorial(5)

combn(5, 3)

choose(5, 3)


# install.packages("gtools")
library(gtools)
urn <- c("red", "blue", "black")
# pick 2 balls from the urn with replacement get all permutations
permutations(n = length(urn), r = 2, v = urn, repeats.allowed = T)
nrow(permutations(n = length(urn), r = 2, repeats.allowed = T))

combinations(3, 2, letters[1:3])



######################################
# Section 4.1                        #
######################################
sample(letters, 50, replace = T)


dice1 <- sample(1:6, 1)
dice2 <- sample(1:6, 1)
dice1 + dice2

n <- 2
my.dice <- function(n){
  dice.no <- sample(1:6, n, replace=T)
  dice.sum <- sum(dice.no)
  output <- c(dice.no, dice.sum)
  names(output) <- c(paste0("dice", 1:n), "sum")
  output
}
my.dice(3)
ans <- replicate(10000000, my.dice(2))
length(which(ans[3,] == 2))/10000000
